program ProxyLib_Demo_Ethernet;

{$APPTYPE CONSOLE}

uses
  SysUtils;


type
  PByte = ^Byte;
  Pinteger=^Single;
  PDataArray = ^DataArray;
  DataArray = array [0..10766] of Single;


function RFDevice_Initialize(): BOOLEAN; cdecl;
  external 'RFDevice_proxy.dll' name 'RFDevice_Initialize';
procedure RFDevice_Cleanup(); cdecl;
  external 'RFDevice_proxy.dll' name 'RFDevice_Cleanup';

function CreateRF603Device(): THandle; cdecl;
  external 'RFDevice_proxy.dll' name 'CreateRF603Device';
function RF603Device_OpenPort(rf620DeviceHandle: THandle; PortName:string; dwSpeed: integer): BOOLEAN; cdecl;
  external 'RFDevice_proxy.dll' name 'RF603Device_EthernetOpenPort';
function RF603Device_ClosePort(rf620DeviceHandle: THandle): BOOLEAN; cdecl;
  external 'RFDevice_proxy.dll' name 'RF603Device_EthernetClosePort';
function RF603Device_StartStream(rf620DeviceHandle: THandle; address: Byte): BOOLEAN; cdecl;
  external 'RFDevice_proxy.dll' name 'RF603Device_StartStream';
function RF603Device_StopStream(rf620DeviceHandle: THandle;  address: Byte): BOOLEAN; cdecl;
  external 'RFDevice_proxy.dll' name 'RF603Device_StopStream';
function RF603Device_GetStreamMeasure(rf620DeviceHandle: THandle; lpusValu:PInteger): BOOLEAN; cdecl;
  external 'RFDevice_proxy.dll' name 'RF603Device_EthernetGetNormalizedStreamMeasure';
procedure DisposeRF603Device(rf620DeviceHandle: THandle); cdecl;
  external 'RFDevice_proxy.dll' name 'DisposeRF603Device';


var
  _connected: boolean;
  _res: boolean;
  _res_1: boolean;
  name: string;
  devCount: integer;
  devType: Word;
  _rfLanDetectorHandle: THandle;
  _rf603DeviceHandle: THandle;
  _devBlockHandle: THandle;
  _arr1: DataArray;
  _arr:Pinteger;
  _arr2,_arr3,_arr4: integer;
  _result:real;
  i: integer;

begin
  try
    _connected := RFDevice_Initialize();
    if _connected <> TRUE then
    begin
      WriteLn('init library');
      ReadLn(name);

    end;
       _rf603DeviceHandle := CreateRF603Device();
    _connected := RF603Device_OpenPort(_rf603DeviceHandle,'COM6',9600);
    if _connected <> TRUE then
    begin
      WriteLn('OpenPort operation error');
      ReadLn(name);
         Exit;
    end;
    _res:=false ;
    _res:= RF603Device_StartStream(_rf603DeviceHandle,1);
    if _res = TRUE then
      begin
        WriteLn('Stream');
      end;
        for i:= 0 to 10 - 1 do
    begin
     _arr := @_arr1;
      _res_1:= RF603Device_GetStreamMeasure(_rf603DeviceHandle, _arr);
      if _res_1 <> TRUE then
      begin
        WriteLn('Getting data error');
      end;
      if _res_1 = TRUE then
      begin
           _result:=((_arr1[i]*200) / 16384);
           Writeln(_arr1[i]:2:3,' mm  ');

      end;
    end;
         _res := RF603Device_StopStream(_rf603DeviceHandle,1);
    if _res = TRUE then
      begin
        WriteLn('Stop');
      end;

       DisposeRF603Device(_rf603DeviceHandle);
       RF603Device_ClosePort(_rf603DeviceHandle);
       RFDevice_Cleanup();
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;

 readln(name);
end.
